/**
 *	Copyright (c) 2008,  Eckhart Arnold
 *
 * Dieses Programm ist freie Software. Sie können es unter den
 * Bedingungen der GNU General Public License, wie von der Free
 * Software Foundation veröffentlicht, weitergeben und/oder
 * modifizieren, entweder gemäß Version 3 der Lizenz oder (nach
 * Ihrer Option) jeder späteren Version.
 *
 * Die Veröffentlichung dieses Programms erfolgt in der Hoffnung,
 * daß es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE
 * GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder
 * der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Details finden
 * Sie in der GNU General Public License.
 *
 * Sie sollten ein Exemplar der GNU General Public License zusammen
 * mit diesem Programm erhalten haben. Falls nicht, siehe
 * <http://www.gnu.org/licenses/>.
 */

package evolution.examples;

import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;

public class About implements ISimulation {
	public static final String infoString = 
		"Beispielsimulationen zu evolutionären Algorithmen\n\n" + 
		"von Eckhart Arnold (www.eckhartarnold.de)\n\n"+
		"Copyright (c) 2008  Eckhart Arnold\n"+
		"unter der: GNU Public License V3\n"+
		"(http://www.gnu.de/documents/gpl-3.0.de.html)\n\n"+
		"Quellcode: www.eckhartarnold.de/german/computers.html#evoldemo\n\n"+
		"Diese Beispielsimulationen beziehen sich auf den Beitrag:\n"+
		"\"Neuheit in evolutionären Algorithmen\" von Eckhart Arnold in:\n"+
		"\"Philosophie des Neuen\" (hrsg. von Peter Seele),\n"+
		"Wissenschaftliche Buchgesellschaft Darmstadt, 2008.\n\n";
	
	boolean finishedFlag = false;

	public StringBuffer accessLog() {
		StringBuffer log = new StringBuffer();
		log.append(infoString);
		log.append("\n\nSoftware-Lizenz:\n\n");
		log.append(GPLV3.LICENSE);
		return log;
	}

	public void drawState(GC gc) {
		String text = infoString + GPLV3.GERMAN_SHORT;
		Rectangle r = gc.getClipping();
		gc.fillRectangle(r);		
		gc.drawText(text, 0, 0, SWT.DRAW_DELIMITER);
	}

	public boolean finished() { return finishedFlag; }

	public String getDescription() { return infoString; }

	public String[] queryMonitors() {
		String[] monitors = {};
		return monitors;
	}

	public double readMonitor(String monitor) {	return 0.0; }

	public void reset() { finishedFlag = false; }

	public void step() { finishedFlag = true; }

	public void terminate() { }
}
